﻿using Infragistics.Win.UltraWinTree;
using System; 
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UltraTreeDataBinding.Data;
using UltraTreeDataBinding.Logic;

namespace UltraTreeDataBinding
{
    public partial class Form1 : Form
    {
        private bool  IsInit =true;
        private DataSet ds;
        private RollupFinancialAccountData m_MyDs;



        public Form1()
        {
            InitializeComponent();

            m_MyDs = new RollupFinancialAccountData();

            // Bind to our member dataset
            ultraTree1.SetDataBinding(m_MyDs, "ROLLUP_FinancialAccount");


                                              
        }


        
        /// <summary>
        /// Set the visibility if it isn't already assigned properly.
        /// </summary>
        private void SetUltraTreeNodeVisibility(UltraTreeNode p_UltraTreeNode, bool p_IsVisible = true)
        {
            if(p_UltraTreeNode.Visible == p_IsVisible) { return; }

            p_UltraTreeNode.Visible = p_IsVisible;
        }
        
        /// <summary>
        /// Called at various times when initializing a node.
        /// Called when a node is first created and when underlying data changes.
        /// (i.e callstack shows that System.Data events can indirectly trigger this handler.)
        /// </summary>
        private void ultraTree1_InitializeDataNode(object p_Sender, Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs p_Args)
        {
            // Is in first level but has a parent!  This is an oddity with the way parent-child data binding works.
            if (p_Args.Node.IsRootLevelNode && (!(p_Args.Node.Cells["ROLLUP_FinancialAccountParent"].Value is System.DBNull)))
            {
                SetUltraTreeNodeVisibility(p_Args.Node, p_IsVisible: false);
            }
            else
            {
                SetUltraTreeNodeVisibility(p_Args.Node);
            }

        }

                                //private void ultraTree1_InitializeDataNode(object sender, Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
                                //{
                                //    //e.Node.DataColumnSetResolved.Columns["ID"].Visible = false;
                                //    //e.Node.DataColumnSetResolved.Columns["PID"].Visible = false;
                                //    //if(IsInit) Init(e);
                                //}

        private void Init(Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
        {
            if (e.Node.Cells["PID"].Text == "0" && e.Node.Index != 0) e.Node.Visible = true;
            else e.Node.Visible = false;
        }

        private static int Depth(RollupFinancialAccountData.ROLLUP_FinancialAccountRow p_Row, int p_LevelsSearched = 0)
        {
            if(p_LevelsSearched > 3) { return p_LevelsSearched; }

            p_LevelsSearched = p_LevelsSearched + 1;

            if (p_Row.IsROLLUP_FinancialAccountParentNull()) { return p_LevelsSearched; }
            
            return Depth(p_Row.ROLLUP_FinancialAccountRowParent, p_LevelsSearched);



        }

                                                        //private static  void InitDataset(RollupFinancialAccountData p_DataTemp)
                                                        //{
                                                        //    var LogicObj = new RandomCharLogic();

                                                        //    foreach(var RowLoop in p_DataTemp.ROLLUP_FinancialAccount)
                                                        //    {
                                                        //        if(Depth(RowLoop) < 3) { continue; }

                                                        //        RowLoop.LevelMemberName = LogicObj.ChangeChars(RowLoop.LevelMemberName);

                                                        //    }
                                                        //    p_DataTemp.WriteXml(@"c:\temp\DataAssignment.xml");

                                                        //    p_DataTemp.AcceptChanges();


                                                        //}

        private void Form1_Load(object sender, EventArgs e)
        {
            IsInit = false;

            RollupFinancialAccountData DataTemp;
            DataTemp = new RollupFinancialAccountData();
            DataTemp.ReadXml(@"DataAssignment.xml");
            //DataTemp.ReadXml(@"c:\temp\DataAssignment.xml");
             

            m_MyDs.ROLLUP_FinancialAccount.Merge(DataTemp.ROLLUP_FinancialAccount);  

        }

    }
}
